defmodule Poex.Pads do
  @moduledoc """
  The Accounts context.
  """

  import Ecto.Query, warn: false
  alias Poex.Repo
  alias Poex.Pads.Document

  def get_pad_document(id), do: Repo.get(Document, id)

  def update_pad_document(%Document{} = document, attrs) do
    document
    |> Document.changeset(attrs)
    |> Repo.update()
  end

  def update_pad_document(id, attrs) do
    Repo.get(Document, id)
    |> case do
      nil ->
        {:error, :not_found}

      document ->
        document
        |> Document.changeset(attrs)
        |> Repo.update()
    end
  end
end
