defmodule Poex.Pads.Operation do
  use Ecto.Schema
  import Ecto.Changeset

  @primary_key {:id, Ecto.UUID, autogenerate: true}
  schema "operations" do
    field :type, :string
    field :value, :map
    field :attributes, :map
    belongs_to :document, Poex.Pads.Document

    timestamps(type: :utc_datetime)
  end

  @doc false
  def changeset(operation, attrs) do
    operation
    |> cast(attrs, [:type, :value, :attributes])
    |> validate_required([:type, :value])
    |> assoc_constraint(:document)
  end
end
